
package de.ivu.elect.presentation.kandidatur;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.ergebnis.entity.Gewaehlt;
import de.ivu.elect.business.kandidatur.boundary.KandidaturGewaehltSearch;
import de.ivu.elect.business.kandidatur.boundary.KandidaturGewaehltSearchParameters;
import de.ivu.elect.business.kandidatur.entity.KandidaturGewaehlt;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.ergebnis.AbstractKumulierteStimmenSearchView;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.kandidatur.table.KandidaturGewaehltColumnBuilder;

@OnlineHilfeId("226")
@ViewAccessScoped
@View(viewId = KandidaturGewaehltSearchView.VIEW_ID, useCase = UseCasePermission.KANDIDATUR_GEWAEHLT_SEARCH)
@Named(KandidaturGewaehltSearchView.COMPONENT_NAME)
public class KandidaturGewaehltSearchView extends AbstractKumulierteStimmenSearchView<KandidaturGewaehltSearchParameters, KandidaturGewaehlt> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "kandidaturGewaehltSearchView";

  public static final String VIEW_ID = "/kandidatur/kandidatur-gewaehlt-search.xhtml";

  @Inject
  private transient KandidaturGewaehltSearch kandidaturGewaehltSearch;

  @Inject
  @ConversationGroup(KandidaturGewaehltSearchParameters.class)
  private transient KandidaturGewaehltSearchParameters kandidaturGewaehltSearchParameters;

  @Inject
  private transient KandidaturGewaehltColumnBuilder kandidaturGewaehltColumnBuilder;

  public KandidaturGewaehltSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    super.addProperties(formBuilder);

    formBuilder.addProperty(getSearchParameters().getPolitischeGruppeSearchProperty(getPolitischeGruppen()));
    formBuilder.addProperty(getSearchParameters().getGewaehltStatusMitLeererAuswahlProperty()).optional();
  }

  @Override
  public KandidaturGewaehltSearchParameters getSearchParametersInternal() {
    return kandidaturGewaehltSearchParameters;
  }

  @Override
  protected KandidaturGewaehltSearch getSearch() {
    return kandidaturGewaehltSearch;
  }

  @Override
  protected KandidaturGewaehltColumnBuilder getColumnBuilder() {
    return kandidaturGewaehltColumnBuilder;
  }

  public List<Gewaehlt> getSearchResultGewaehlte() {
    List<KandidaturGewaehlt> kandidaturenGewaehlt = getSearchResult();
    List<Gewaehlt> result = new ArrayList<>(kandidaturenGewaehlt.size());

    for (KandidaturGewaehlt kandidaturGewaehlt : kandidaturenGewaehlt) {
      result.add(kandidaturGewaehlt.getGewaehlt());
    }

    return result;
  }

  public boolean isBtnBenachrichtigenRendered() {
    return false; // nicht mehr notwendig, da im Gesamtergebnis vorhanden...
  }

  public boolean isBtnBenachrichtigenDisabled() {
    return isEmptySearchResultDisplayed();
  }
}
